Require Import ssreflect ssrfun ssrbool ssrnat seq eqtype.
Require Import mtac.
Set Implicit Arguments.
Unset Strict Implicit.
Import Prenex Implicits.

Set Printing Existential Instances.

Structure dyn := Dyn { ty : Type; el : ty }.

Program Definition remove {A} (x : A) :=
  mfix f (s : seq A) : M seq A :=
    mmatch s return M seq A with
    | [s'] (x :: s') => f s'
    | [y s'] (y :: s') => 
      r <- f s';
      ret (y :: r)
    | _ => ret s
    end.

Program Definition fv :=
  mfix fv (d : dyn) : M (seq dyn) :=
    mmatch d return M seq dyn with
    | [B C (f : B -> C)] Dyn (fun y:B => f y) =c>
      nu (y : B),
        f' <- retS (f y);
        r <- fv (Dyn f');
        remove (Dyn y) r
    | [A B (x:A) (f : A -> B)] Dyn (f x) =c>
      r1 <- fv (Dyn f);
      r2 <- fv (Dyn x);
      ret (r1 ++ r2) 
    | [A (x:A)] Dyn x =c>
      b <- is_var x;
      if b return M (seq dyn) then ret [:: Dyn x]
      else ret [::]
    end.

Definition test_fv1 : (run (fv (Dyn (fun x:nat=>x)))) = [::] := erefl _.
Definition test_fv2 (y:nat) : (run fv (Dyn (fun x:nat=>y))) = [:: Dyn y] := erefl _.

Unset Use Munify.
Definition test_fv3 (y:nat) : (run fv (Dyn (fun x:nat->nat=>x y))) = [:: Dyn y] := erefl _.

