Require Import mtac.

Program Definition swap {A} {B} {P} : 
  (forall x:A, exists y : B, P x y) -> 
  M (exists f : A -> B, forall x : A, P x (f x)) :=
fun H=>
  nu x : A,
    let (y, Pxy) := H x in 
    b <- abs_eq x y;
    let (f, eq) := b in
    let Pxfx : P x (f x) := eq_ind_r (fun b' : B => P x b') Pxy eq in
    r <- @abs _ (fun y=>P y (f y)) x Pxfx;
    ret (ex_intro _ f r).

Lemma test : forall x : nat, exists y, y > x.
Proof.
  intro x; exists (S x).
  auto.
Defined.

Check (run (swap test >> retS)).
